# SYNOPSIS
#
#   AX_ARG_ENABLE(FEATURE, OPTIONAL_VALUE_DESCRIPTION, HELP-STRING)
#
# DESCRIPTION
#
#   Basic replacement for AC_ARG_ENABLE().
#   FEATURE must include the '--enable' or '--disable' prefix.
#
# LAST MODIFICATION
#
#   2006-12-12
#
# COPYLEFT
#
#   Copyright (c) 2006 Nicolas Calimet
#
#   Copying and distribution of this file, with or without
#   modification, are permitted in any medium without royalty provided
#   the copyright notice and this notice are preserved.

AC_DEFUN([AX_ARG_ENABLE],
[
  # remove enable|disable prefix and convert dash to underscore
  ax_arg_enable_feature=`echo $1 | sed 's,^--.*able-,,; s,-,_,g'`

  # AC_ARG_ENABLE does only accept a litteral for feature name / help string
  eval "enable_ax_arg_enable_val=\${enable_$ax_arg_enable_feature}"

  AC_ARG_ENABLE([ax_arg_enable_val],
    [AS_HELP_STRING([$1], [$2])],
    [
      case $enable_ax_arg_enable_val in
        yes|no|"")  eval "enable_${ax_arg_enable_feature}=$enable_ax_arg_enable_val" ;;
        *)          AC_MSG_ERROR([bad value '$enable_ax_arg_enable_val' for $1]) ;;
      esac
    ],
    [eval "enable_${ax_arg_enable_feature}="]
  )
])
