# SYNOPSIS
#
#   AX_ARG_WITH(FEATURE, OPTIONAL_VALUE_DESCRIPTION, HELP-STRING)
#
# DESCRIPTION
#
#   Basic replacement for AC_ARG_WITH().
#   FEATURE must include the '--with' or '--without' prefix.
#
# LAST MODIFICATION
#
#   2007-11-08
#
# COPYLEFT
#
#   Copyright (c) 2006 Nicolas Calimet
#
#   Copying and distribution of this file, with or without
#   modification, are permitted in any medium without royalty provided
#   the copyright notice and this notice are preserved.

AC_DEFUN([AX_ARG_WITH],
[
  # remove with|without prefix and convert dash to underscore
  ax_arg_with_feature=`echo $1 | sed 's,^--with[[^-]]*-,,; s,-,_,g'`

  # AC_ARG_WITH does only accept a litteral for feature name / help string
  eval "with_ax_arg_with_val=\${with_$ax_arg_with_feature}"

  AC_ARG_WITH([ax_arg_with_val],
    [ifelse(len($2), 0, AS_HELP_STRING([$1], [$3]), AS_HELP_STRING([$1@<:@=$2@:>@], [$3]))],
    [
      if test x"$2" = x""; then
        case $with_ax_arg_with_val in
          yes|no|"")  eval "with_${ax_arg_with_feature}=$with_ax_arg_with_val" ;;
          *)          AC_MSG_ERROR([incorrect value '$with_ax_arg_with_val' for $1]) ;;
        esac
      else
        eval "with_${ax_arg_with_feature}=$with_ax_arg_with_val"
      fi
    ],
    [eval "with_${ax_arg_with_feature}="]
  )
])
